<?php
/**
 * co_campo_det_con actions.
 *
 * @package    contratacion
 * @subpackage co_campo_det_con
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */

class co_campo_det_conActions extends sfActions
{
    /**
  * Executes list action
  *
  * @param sfRequest $request A request object
  */
    public function executeList(sfWebRequest $request)
    {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        
        
        
        
        try{
            
            
             /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }
            
            
            
            if (isset($request['id_estudios_previos'])) {
                $whereIdEstudiosPrevios='and tab0.id_estudios_previos='.$request['id_estudios_previos'];
            } else {
                $whereIdEstudiosPrevios = '';
            }
            
            
            
            if (isset($request['codigos'])) {
                $var = strtolower($request['codigos']);
                $whereCodigos='and lower(tab2.campo_ep.codigo) LIKE %'.$var;
            } else {
                $whereCodigos = "and lower(tab2.campo_ep.codigo) LIKE '%valor%' or lower(tab2.campo_ep.codigo) LIKE '%superv%'";
            }
            
            
            
            
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            
            $sql = <<<EOD
                    
                    select count(*) as count from(
                    select 
tab2.campo_ep.id_campo_ep as id_campo_ep,
tab2.campo_ep.codigo as codigo,
tab2.campo_ep.descripcion AS descripcion,                     
tab2.campo_ep.estado as estado,
tab2.campo_ep.tipo_campo as tipo_campo,
case when tab7.valor is null then tab2.default_value else tab7.valor end as valor,  
tab2.campo_ep.fase_ep.orden as HOJA,
tab2.orden
from co_estudios_previos tab0
join co_modalidad_sel tab1 on tab0.id_modalidad_sel=tab1.id_modalidad_sel
left join co_campo_modalidad tab2 on tab1.id_modalidad_sel=tab2.id_modalidad_sel
left join co_detalle_ep tab7 on tab0.id_estudios_previos=tab7.id_estudios_previos and tab2.campo_ep.id_campo_ep=tab7.id_campo_ep
left join co_campo_obliga tab8 ON tab8.id_modalidad_sel = tab0.id_modalidad_sel and tab8.id_campo_ep = tab2.campo_ep.id_campo_ep    
where
1=1  
$whereIdEstudiosPrevios
$whereCodigos                    
order by tab2.campo_ep.fase_ep.orden,tab2.orden 
    )ta
EOD;
         
            
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            
            
            if($total_record_count>0){
                
                
                $sql = <<<EOD
                    select 
tab2.campo_ep.id_campo_ep as id_campo_ep,
tab2.campo_ep.codigo as codigo,
tab2.campo_ep.descripcion AS descripcion,                     
tab2.campo_ep.estado as estado,
tab2.campo_ep.tipo_campo as tipo_campo,
case when tab7.valor is null then tab2.default_value else tab7.valor end as valor,  
tab2.campo_ep.fase_ep.orden as HOJA,
tab2.orden
from co_estudios_previos tab0
join co_modalidad_sel tab1 on tab0.id_modalidad_sel=tab1.id_modalidad_sel
left join co_campo_modalidad tab2 on tab1.id_modalidad_sel=tab2.id_modalidad_sel
left join co_detalle_ep tab7 on tab0.id_estudios_previos=tab7.id_estudios_previos and tab2.campo_ep.id_campo_ep=tab7.id_campo_ep
left join co_campo_obliga tab8 ON tab8.id_modalidad_sel = tab0.id_modalidad_sel and tab8.id_campo_ep = tab2.campo_ep.id_campo_ep    
where
1=1  
$whereIdEstudiosPrevios
$whereCodigos                        
order by tab2.campo_ep.fase_ep.orden,tab2.orden 
EOD;
                $records = CN_TABLE::executeSQL($sql);
                            
                
                
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowStart + count($records);
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[co_campo_det_con] Consulta exitosa.");
                
                
            }
            else{
                
                $mensaje = "[co_campo_det_con] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
                
                
                
                
            }
            
        } catch (Exception $ex) {
            
            
            $error = "[co_campo_det_con] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);

        }
        
    }
    
    
    
    
    
    
}